#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <sys/stat.h>

#include "asim/rrr/service_ids.h"

#include "asim/provides/connected_application.h"



using namespace std;

// ===== service instantiation =====
AUDIOPROCESSORRRR_SERVER_CLASS AUDIOPROCESSORRRR_SERVER_CLASS::instance;

// constructor
AUDIOPROCESSORRRR_SERVER_CLASS::AUDIOPROCESSORRRR_SERVER_CLASS() :
    serverStub(new AUDIOPROCESSORRRR_SERVER_STUB_CLASS(this))
{
    // instantiate stub
    printf("AUDIOPROCESSORRR init called\n");
    outputFile = NULL;
}

// destructor
AUDIOPROCESSORRRR_SERVER_CLASS::~AUDIOPROCESSORRRR_SERVER_CLASS()
{
    Cleanup();
}

// init
void
AUDIOPROCESSORRRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)
{
    parent = p;
}

// uninit
void
AUDIOPROCESSORRRR_SERVER_CLASS::Uninit()
{
    Cleanup();
}

// cleanup
void
AUDIOPROCESSORRRR_SERVER_CLASS::Cleanup()
{
    delete serverStub;
}


//
// RRR service methods
//

void
AUDIOPROCESSORRRR_SERVER_CLASS::SendProcessedStream(UINT16 control, UINT16 data)
{

  AudioProcessorControl audioProcessorControl = (AudioProcessorControl) control;
  switch(control) {
    case EndOfFile:
      if(outputFile != NULL) {
        fflush(outputFile);
        fclose(outputFile);
        outputFile = NULL;
      } else {
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
        fflush(outputFile);
        fclose(outputFile);
      }

      CONNECTED_APPLICATION_CLASS::EndSimulation(); 
    break;

    case Data:
      if(outputFile == NULL) {
        outputFile = fopen("out_hw.pcm","w");
        assert(outputFile);
      }

      CONNECTED_APPLICATION_CLASS::UpdateSemaphore();  
      fwrite(&data, 2,1 , outputFile);
    break;
  }
 
}

